package com.nisum.employeeservice.service;

import com.nisum.employeeservice.model.Employee;
import com.nisum.employeeservice.repository.EmployeeRepository;
import org.junit.Assert;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.Mockito;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.Arrays;
import java.util.List;

import static org.junit.jupiter.api.Assertions.*;

//@RunWith(SpringRunner.class)
@SpringBootTest
class EmployeeServiceTest {

  @Mock EmployeeRepository mockedEmployeeRepository;
  @InjectMocks EmployeeService mockedEmployeeService;


  @Autowired
  EmployeeRepository employeeRepository;
  @Autowired
  EmployeeService employeeService;

  @BeforeEach
  void setUp() {
  }

  @AfterEach
  void tearDown() {
  }

  @Test
  void findAllEmployees() {
    Employee employee = new Employee();
    employee.setId(1L);
    employee.setFirstName("Tom");
    employee.setLastName("Smith");

    Employee employee1 = new Employee();
    employee1.setId(2L);
    employee1.setFirstName("Jane");
    employee1.setLastName("Doe");

    List<Employee> employeeList = Arrays.asList(employee, employee1);
    Mockito.when(mockedEmployeeRepository.findAll()).thenReturn(employeeList);

    List<Employee> resultList = mockedEmployeeService.findAllEmployees();
    assertEquals(2, resultList.size());
  }

  @Test
  void addEmployeeMocked() {

  }

  @Test
  void addEmployee() {
    Employee employee = new Employee();
    employee.setFirstName("Tom");
    employee.setLastName("Smith");
    employeeService.addEmployee(employee);
    Employee employee1 = new Employee();
    employee1.setFirstName("Jane");
    employee1.setLastName("Doe");
    employeeService.addEmployee(employee1);
    List<Employee> employeeList = employeeService.findAllEmployees();
    assertEquals(1, employeeList.size());
  }
}